#include <stdio.h>

typedef struct {
	int matricola;
	char nome[30];
	char cognome[30];
} studente;

typedef struct {
	int matricola;
	char corso[30];
	int voto;
	int lode;
} esame;

void media(studente studenti[], int sdim, esame esami[], int edim, int matricola);

int esiste(studente studenti[], int index, int matricola);

int main(){

	int n, m;
	printf("Quanti sono gli studenti?\n");
	scanf("%d", &n);

	studente studenti[n];

	int matricola;

	for(int i=0;i<n;i++){
		printf("Inserisci i dati dello studente n. %d\n",i);

		int ripeti=0;
		do{
			printf("Matricola ");
			scanf("%d", &matricola);
			if(esiste(studenti, n, matricola)){
				printf("La matricola inserita esiste gia'\n");
				ripeti=1;
			}else
				ripeti=0;
		}while(ripeti);

		getchar();

		studenti[i].matricola=matricola;
		printf("Nome ");
		gets(studenti[i].nome);
		printf("Cognome ");
		gets(studenti[i].cognome);
	}

	printf("Quanti sono gli esami?\n");
	scanf("%d", &m);

	esame esami[m];
	for(int i=0;i<m;i++){
		printf("Inserisci i dati dell'esame n. %d\n",i);

		int ripeti=0;
		do{
			printf("Matricola ");
			scanf("%d", &matricola);
			if(!esiste(studenti, n, matricola)){
				printf("La matricola inserita non esiste\n");
				ripeti=1;
			}else
				ripeti=0;
		}while(ripeti);

		getchar();

		esami[i].matricola=matricola;
		printf("Corso ");
		gets(esami[i].corso);
		printf("Voto ");
		scanf("%d", &esami[i].voto);
		printf("Lode ");
		scanf("%d", &esami[i].lode);

	}

	printf("Inserisci una matricola (-1 per terminare)\n");
	scanf("%d", &matricola);

	while(matricola!=-1){
		media(studenti,n,esami,m,matricola);
		printf("Inserisci una matricola (-1 per terminare)\n");
		scanf("%d", &matricola);
	}

}

void media(studente studenti[], int sdim, esame esami[], int edim, int matricola){
	int trovato=0;

	for(int i=0; i<sdim; i++){
		if(studenti[i].matricola==matricola){
			printf("%s %s media: ", studenti[i].cognome, studenti[i].nome);
			trovato=1;
		}
	}

	if(!trovato)
		printf("la matricola inserita non e' valida\n");
	else{
		double somma=0.0;
		int count=0;
		for(int i=0;i<edim;i++){
			if(esami[i].matricola==matricola){
				somma+=esami[i].voto;
				count++;
			}
		}
		if(count>0)
			printf("%g\n",(somma/count));
		else
			printf("%g\n",somma);
	}

}

int esiste(studente studenti[], int index, int matricola){
	int esiste=0;
	for(int i=0;i<index;i++)
		if(studenti[i].matricola==matricola)
			esiste=1;
	return esiste;
}
